// VBX Wizard Include File
//
// Copyright (C) 1993, Sax Software
// All rights reserved.

#ifndef _VBXWIZRD_H

#define _VBXWIZRD_H

class CVBXWizardProperty : public CObject
	{
public:
	CVBControl *m_pVBControl;
	int m_nID;
	CVBXWizardProperty(CVBControl *pVBControl, int nID)
		{
		m_pVBControl = pVBControl;
		m_nID = nID;
		};
	CVBXWizardProperty(CVBXWizardProperty &x)
		{
		m_pVBControl = x.m_pVBControl;
		m_nID = x.m_nID;
		}
	};

class CHszProperty : public CVBXWizardProperty
	{
public:
	CHszProperty(CVBControl *pVBControl, int nID) :
		CVBXWizardProperty(pVBControl, nID) {};
	void operator =(LPCSTR lpszValue)
		{
		m_pVBControl->SetStrProperty(m_nID, lpszValue);
		};
	operator CString()
		{
		return m_pVBControl->GetStrProperty(m_nID);
		};
	};

class CShortProperty : public CVBXWizardProperty
	{
public:
	CShortProperty(CVBControl *pVBControl, int nID) :
		CVBXWizardProperty(pVBControl, nID) {};
	void operator = (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID, nValue);
		};
	void operator += (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) + nValue);
		};
	void operator -= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) - nValue);
		};
	void operator *= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) * nValue);
		};
	void operator /= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) / nValue);
		};
	void operator %= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) % nValue);
		};
	void operator ^= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) ^ nValue);
		};
	void operator &= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) & nValue);
		};
	void operator |= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) | nValue);
		};
	void operator <<= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) << nValue);
		};
	void operator >>= (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) >> nValue);
		};
	int operator ++ (int)
		{
		int nValue = (int)m_pVBControl->GetNumProperty(m_nID) + 1;
		m_pVBControl->SetNumProperty(m_nID, nValue);
		return nValue;
		};
	int operator -- (int)
		{
		int nValue = (int)m_pVBControl->GetNumProperty(m_nID) - 1;
		m_pVBControl->SetNumProperty(m_nID, nValue);
		return nValue;
		};
	int operator ++ ()
		{
		int nValue = (int)m_pVBControl->GetNumProperty(m_nID) + 1;
		m_pVBControl->SetNumProperty(m_nID, nValue);
		return nValue;
		};
	int operator -- ()
		{
		int nValue = (int)m_pVBControl->GetNumProperty(m_nID) - 1;
		m_pVBControl->SetNumProperty(m_nID, nValue);
		return nValue;
		};
	operator int()
		{
		return (int)m_pVBControl->GetNumProperty(m_nID);
		};
	};

class CLongProperty : public CVBXWizardProperty
	{
public:
	CLongProperty(CVBControl *pVBControl, int nID) :
		CVBXWizardProperty(pVBControl, nID) {};
	void operator = (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
	void operator += (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) + lValue);
		};
	void operator -= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) - lValue);
		};
	void operator *= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) * lValue);
		};
	void operator /= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) / lValue);
		};
	void operator %= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) % lValue);
		};
	void operator ^= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) ^ lValue);
		};
	void operator &= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) & lValue);
		};
	void operator |= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) | lValue);
		};
	void operator <<= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) << lValue);
		};
	void operator >>= (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID,
					  m_pVBControl->GetNumProperty(m_nID) >> lValue);
		};
	LONG operator ++ (int)
		{
		LONG lValue = m_pVBControl->GetNumProperty(m_nID) + 1;
		m_pVBControl->SetNumProperty(m_nID, lValue);
		return lValue;
		};
	LONG operator -- (int)
		{
		LONG lValue = m_pVBControl->GetNumProperty(m_nID) + 1;
		m_pVBControl->SetNumProperty(m_nID, lValue);
		return lValue;
		};
	LONG operator ++ ()
		{
		LONG lValue = m_pVBControl->GetNumProperty(m_nID) + 1;
		m_pVBControl->SetNumProperty(m_nID, lValue);
		return lValue;
		};
	LONG operator -- ()
		{
		LONG lValue = m_pVBControl->GetNumProperty(m_nID) - 1;
		m_pVBControl->SetNumProperty(m_nID, lValue);
		return lValue;
		};
	operator LONG()
		{
		return m_pVBControl->GetNumProperty(m_nID);
		};
	};

class CBoolProperty : public CShortProperty
	{
public:
	CBoolProperty(CVBControl *pVBControl, int nID) :
		CShortProperty(pVBControl, nID) {};
	void operator = (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID, nValue);
		};
	};

class CColorProperty : public CLongProperty
	{
public:
	CColorProperty(CVBControl *pVBControl, int nID) :
		CLongProperty(pVBControl, nID) {};
	void operator=(LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
	};

class CEnumProperty : public CShortProperty
	{
public:
	CEnumProperty(CVBControl *pVBControl, int nID) :
		CShortProperty(pVBControl, nID) {};
	void operator = (int nValue)
		{
		m_pVBControl->SetNumProperty(m_nID, nValue);
		};
	};

class CRealProperty : public CVBXWizardProperty
	{
public:
	CRealProperty(CVBControl *pVBControl, int nID) :
		CVBXWizardProperty(pVBControl, nID) {};
	void operator=(float flValue)
		{
		m_pVBControl->SetFloatProperty(m_nID, flValue);
		};
	operator float()
		{
		return m_pVBControl->GetFloatProperty(m_nID);
		};
	};

class CXPosProperty : public CLongProperty
	{
public:
	CXPosProperty(CVBControl *pVBControl, int nID) :
		CLongProperty(pVBControl, nID) {};
	void operator = (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
	};

class CXSizeProperty : public CLongProperty
	{
public:
	CXSizeProperty(CVBControl *pVBControl, int nID) :
		CLongProperty(pVBControl, nID) {};
	void operator = (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
	};

class CYPosProperty : public CLongProperty
	{
public:
	CYPosProperty(CVBControl *pVBControl, int nID) :
		CLongProperty(pVBControl, nID) {};
	void operator = (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
	};

class CYSizeProperty : public CLongProperty
	{
public:
	CYSizeProperty(CVBControl *pVBControl, int nID) :
		CLongProperty(pVBControl, nID) {};
	void operator = (LONG lValue)
		{
		m_pVBControl->SetNumProperty(m_nID, lValue);
		};
		};

class CPictureProperty : public CVBXWizardProperty
	{
	CPictureProperty(CVBControl *pVBControl, int nID) :
		CVBXWizardProperty(pVBControl, nID) {};
	void operator = (HPIC hPic)
		{
		m_pVBControl->SetPictureProperty(m_nID, hPic);
		};
	operator HPIC()
		{
		return m_pVBControl->GetPictureProperty(m_nID);
		};
	};
#endif
